#!/bin/sh

# do not inherit from CE via batch system wrapper
unset GLITE_LOCATION LCG_LOCATION EDG_LOCATION GLOBUS_LOCATION

if test "x${GLITE_MW_VERSION:-$EDG_MW_VERSION}" != x
then
    if test "x$GLITE_SW_TOP" = x
    then
	eval `
	    unset GLITE_MW_VERSION EDG_MW_VERSION
	    bash --login -c '
		echo export \
		    GLITE_SW_TOP=${VO_DTEAM_SW_DIR:-VO_DTEAM_SW_DIR_undefined} \
		    glite_loc=${GLITE_LOCATION:-GLITE_LOCATION_undefined}
	    '
	`
    fi

    vers_cmd=$glite_loc/bin/glite-version
    version=

    if test -x $vers_cmd
    then
	version=`$vers_cmd`
    fi

    while test "x$version" != "x${GLITE_MW_VERSION:-$EDG_MW_VERSION}"
    do
	case $GLITE_SW_TOP in
	/*)
	    platform=

	    for file in $glite_loc/etc/platform $GLITE_SW_TOP/etc/platform
	    do
		if test -r $file
		then
		    platform=`cat $file`
		    break
		fi
	    done

	    if test "x$platform" = x
	    then
		version=`
		    gcc -v 2>&1 | sed -n '$s/^gcc version \([^ ]*\).*/\1/p'
		`

		# hack...

		case $version in
		3.2.3)
		    platform=SL3_`arch`
		    ;;
		3.4.6)
		    platform=SL4_`arch`
		    ;;
		*)
		    platform=platform_unknown
		esac
	    fi

	    base=$GLITE_SW_TOP/$platform/${GLITE_MW_VERSION:-$EDG_MW_VERSION}
	    script=$base/etc/profile.d/grid_env.sh

	    if test -r "$script"
	    then
		. "$script"
		break
	    fi
	esac

	export EDG_MW_VERSION=not_found:${GLITE_MW_VERSION:-$EDG_MW_VERSION}
	export GLITE_MW_VERSION=$EDG_MW_VERSION
	break
    done
fi

unset glite_loc vers_cmd version file platform base script
